
from django.contrib.auth.backends import BaseBackend
from .models import Plot

class CompositeAuthorization(BaseBackend):
    def has_perm(self, user, perm, obj=None):
        
        if perm not in ["uhepp_vault.view_plot", "uhepp_vault.view_collection"]:
            return False

        if obj is None:
            return True

        if not isinstance(obj, Plot):
            return False

        return user.has_perm("uhepp_vault.view_collection", obj.collection)

