from django.urls import path, include
from rest_framework import routers

from . import views

urlpatterns = [
    path('collections/', views.CollectionList.as_view(),
         name="collection-index"),
    path('collections/<str:pk>/', views.CollectionDetail.as_view(),
         name="collection-detail"),
    path('plots/', views.PlotCreate.as_view(),
         name="plot-create"),
    path('plots/<str:pk>', views.PlotDetail.as_view(),
         name="plot-detail"),
]
